
<?php
/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

global $_CB_framework,$mosConfig_lang;

$absolute_path = $_CB_framework->GetCfg('absolute_path');
require_once($absolute_path . "/components/com_comprofiler/plugin/user/plug_cbadvancedsearch/admin.advancedsearch.html.php");
require_once($absolute_path . "/components/com_comprofiler/plugin/user/plug_cbadvancedsearch/cb_search.class.php");

// Get the right language if it exists
if (file_exists($absolute_path . '/components/com_comprofiler/plugin/user/plug_cbadvancedsearch/languages/'.$mosConfig_lang.'.php')) {
	include ($absolute_path . '/components/com_comprofiler/plugin/user/plug_cbadvancedsearch/languages/'.$mosConfig_lang.'.php');
} else {
	include ($absolute_path . '/components/com_comprofiler/plugin/user/plug_cbadvancedsearch/languages/english.php');
}

//Get the CB language file

$UElanguagePath= $absolute_path.'/components/com_comprofiler/plugin/language';
if (file_exists($UElanguagePath.'/'.$mosConfig_lang.'/'.$mosConfig_lang.'.php')) {
  include_once($UElanguagePath.'/'.$mosConfig_lang.'/'.$mosConfig_lang.'.php');
} else include_once($UElanguagePath.'/default_language/default_language.php');

class advancedsearchAdmin {
    function menu( &$plugin, $menu, &$params ) {

    $cid=mosGetParam($_POST,'cid',array());
		switch ( $menu ) {

        
       case "config" :
		$this->showconfig($plugin);
		break;

	case "saveconfig" :
		$this->saveconfig($plugin, 1);
		break;

	case "update" :
		$this->update($plugin);
		break;

	case "sql" :
		$this->sql_list($plugin, 1);
		break;

	case "sql2" :
		$this->sql_list($plugin, 2);
		break;
  	
  	case "published" :
		$this->published($plugin,$cid, 1);
		break;
	case "unpublished" :
		$this->published($plugin,$cid, 0);
		break;
	
	case "fields":
		$this->fields($plugin);
		break;
	
	case "save":
		$this->save($plugin, $category);
		break;
	
	case "sql_default":
		 $this->sql_default($plugin,$cid, 1,  $category);
	
	case "sql_edit1" :
		$this->edit($plugin,$id,  1);
		break;       

	case "sql_edit2" :
		$this->edit($plugin,$id,  2);
		break;       

	case "sql_del" :
		$this->remove($plugin, $cid,  $category);
		break;       
		
	case "sql_new": 
		$this->edit($plugin,'0',  1);
		break;

	case "sql_new2": 
		$this->edit($plugin,'0',  2);
		break;
		
	case "sql_cancel":
		$this->sql_cancel($plugin, $category);
		break;
	
	case "sql_cancel2":
		$this->sql_cancel2($plugin, $category);
		break;

	case "searchable":
		$this->searchable($plugin,$cid, 1);
		break;
		
	case "unsearchable":
		$this->searchable($plugin,$cid, 0);
		break;

	case "orderup":
		$this->order($plugin,$cid[0],-1);
		break;
		
	case "orderdown":
		$this->order($plugin,$cid[0],1);
		break;
	
	case 'saveorder':
		$this->saveOrder($plugin, $cid);
		break;
			
	default :
		$this->showmenu($plugin);
		break;
        }
    }



/**
* Shows the Main Menu
*
*/
function showmenu($plugin) {
	HTML_cbas :: showmenu($plugin);
}

function showconfig($plugin){
	HTML_cbas :: showconfig($plugin);
}

function saveconfig($plugin, $saveexit) {
	global $database, $mosConfig_absolute_path;

	//We check if the default section has been correctly set
	$check_default = intval(mosGetParam( $_POST, 'cbsa_logical_default', 0));
	$check_equal  = intval(mosGetParam( $_POST, 'cbsa_logical_equal', 0));
	$check_and    = intval(mosGetParam( $_POST, 'cbsa_logical_and', 0));
	$check_or     = intval(mosGetParam( $_POST, 'cbsa_logical_or', 0));
	$check_not    = intval(mosGetParam( $_POST, 'cbsa_logical_not', 0));
	
	if ( $check_equal + $check_and + $check_or + $check_not > 0){
		switch ($check_default){
			case "0":
				if ($check_equal==0){
					$default_error = 1;
					$default_msg = _CB_AS_DEFAULT_ERROR;
				}
				break;
			case "1":
	 			if ($check_and==0){
					$default_error = 1;
					$default_msg = _CB_AS_DEFAULT_ERROR;
				}
				break;					
			case "2":
				if ($check_or==0){
					$default_error = 1;
					$default_msg = _CB_AS_DEFAULT_ERROR;
				}
				break;					
	                case "3":
	  			if ($check_not==0){
					$default_error = 1;
					$default_msg = _CB_AS_DEFAULT_ERROR;
				}
				break;			              
	  	}
	
		//We check the query worked
		if ($default_error==1) {
			echo "<script>alert('".$default_msg."'); window.history.go(-1);</script>\n";
			exit;
		}
	}

	$row = new cbsaConfig();
	if (!$row->bind($_POST)) {
		mosRedirect('index2.php?option=com_comprofiler&task=pluginmenu&cid='.$plugin->id.'&menu=config', $row->getError());
	}

	$config = "<?php \n";
	$config .= $row->getVarText();
	$config .= '?>';
        
	$fname = $mosConfig_absolute_path.'/components/com_comprofiler/plugin/user/plug_cbadvancedsearch/cb_search.config.php';
	
	$enable_write = mosGetParam($_POST, 'enable_write', 0);
	$oldperms = fileperms($fname);
	if ($enable_write) {
		@ chmod($fname, $oldperms | 0222);
	}
        
	$msg = $gsg_msg;
	
	if (!$gsg_error){
		if ($fp = fopen($fname, 'w')) {
			fputs($fp, $config, strlen($config));
			fclose($fp);
			if ($enable_write) {
				@ chmod($fname, $oldperms);
			} else {
				if (mosGetParam($_POST, 'disable_write', 0))
					@ chmod($fname, $oldperms & 0777555);
			} // if

                        
			if($saveexit){
				   mosRedirect('index2.php?option=com_comprofiler&task=pluginmenu&cid='.$plugin->id.'&menu=manage',_CB_AS_CONFIGSAVED);
			} else {
			       mosRedirect('index2.php?option=com_comprofiler&task=pluginmenu&cid='.$plugin->id.'&menu=config');
			}
			
		} else {
			if ($enable_write) {
				@ chmod($fname, $oldperms);
			}
			mosRedirect('index2.php?option=com_comprofiler&task=pluginmenu&cid='.$plugin->id.'&menu=config',_CB_AS_CONFIGSAVED);
		}
	} else {
	mosRedirect('index2.php?option=com_comprofiler&task=pluginmenu&cid='.$plugin->id.'&menu=config');
	}

}

function sql_list($plugin, $cat){
	global $database;
	$query = "SELECT *"."\n FROM #__cb_search WHERE category=$cat";

	$database->setQuery($query);
	$rows = $database->loadObjectList();

	HTML_cbas :: sql_list($plugin, $rows, $cat);
}

function published($plugin,$cid = null, $published = 1) {
	global $database, $mosConfig_absolute_path;

	if (count($cid) < 1) {
		$action = $published ? _gsg_active_make : _gsg_active_notmake;
		echo "<script>alert('"._gsg_active_select.$action."'); window.history.go(-1);</script>\n";
		exit;
	}


	$cids = implode(',', $cid);
	$query = "UPDATE #__cb_search SET published=$published"."\n WHERE id IN ($cids)";

	$database->setQuery($query);
	if (!$database->query()) {
		echo "<script>alert('".$database->getErrorMsg()."'); window.history.go(-1);</script>\n";
		exit;
	}

	if (count($cid) == 1) {
		$row = new cbs_table($database);
		$row->checkin($cid[0]);
	}

	mosRedirect('index2.php?option=com_comprofiler&task=pluginmenu&cid='.$plugin->id.'&menu=fields');
}

function edit($plugin,$id,  $category){
	global $database;
	$row = new cbs_table($database);
	$row->load($id);
	
	HTML_cbas :: edit($plugin, $row, $category);	
}

function save($plugin){
  global $database, $my;
  $row = new cbs_table($database);

  if(!$row->bind( $_POST)){
    echo"<script> alert('".$row->getError()."'); window.history.go(-1);</script>n";
    exit();
  }

  //Need to script default section
  //We first check if the default has been set to Yes
  $default_save = intval(mosGetParam( $_REQUEST, 'default', '' ));
  
  if($default_save==1){
          //We set all entries to Zero
	  $query = "UPDATE #__cb_search as j SET j.default = 0;";
	  $database->setQuery( $query );
	  $database->query();
  }

  if(!$row->store()){
    echo"<script> alert('".$row->getError()."'); window.history.go(-1);</script>n";
    exit();
  }
 
 if ($category==1){
 	$task = "sql";
	} else {
 	$task = "sql2";
 }
 
  mosRedirect("index2.php?option=com_comprofiler&task=pluginmenu&cid=$plugin->id&menu=$task&category=$category", "Saved");
}

function fields($plugin){
  global $database, $mainframe, $mosConfig_list_limit;
  
	  $query = "SELECT jf.ordering AS ordering, j.fieldid AS jid, jf.id AS id, jf.search AS search, j.name AS name, j.published AS published, j.profile AS profile"
	  	. "\n FROM #__comprofiler_fields AS j LEFT JOIN #__cb_search_fields AS jf"
	  	. "\n ON j.fieldid = jf.fieldid"
	  	. "\n WHERE ((( j.name)<>'NA') AND (( j.published)=1) AND (( j.profile)=1))"
	  	. "\n ORDER BY jf.ordering;";

	  $database->setQuery( $query );
          $rows = $database->loadObjectList();
	  
	require_once( $GLOBALS['mosConfig_absolute_path'] . '/administrator/includes/pageNavigation.php' );
	
	$total = count($rows);
	$limit = $mainframe->getUserStateFromRequest( "viewlistlimit", 'limit', $mosConfig_list_limit );
	$limitstart = $mainframe->getUserStateFromRequest( "viewlimitstart", 'limitstart', 0 );
	$pageNav = new mosPageNav( $total, $limitstart, $limit );

	  
	  HTML_cbas :: fields($plugin, $rows, $pageNav);
	    
}

function sql_cancel($plugin, $category){
	mosRedirect('index2.php?option=com_comprofiler&task=pluginmenu&cid='.$plugin->id.'&menu=sql&category='.$category);
}

function sql_cancel2($plugin, $category){
	mosRedirect('index2.php?option=com_comprofiler&task=pluginmenu&cid='.$plugin->id.'&menu=sql2&category='.$category);
}

function sql_default($plugin,$cid, $default=1,  $category){
	global $database;
	
	//we clear all previous values
	  $query = "UPDATE #__cb_search as j SET j.default = 0 WHERE category=$category;";
	  $database->setQuery( $query );
	  $database->query();
	  
	mosCache :: cleanCache('com_cb_search');

	$cids = implode(',', $cid);
	$query = "UPDATE #__cb_search as j SET j.default=$default"."\n WHERE id IN ($cids)";

	$database->setQuery($query);
	if (!$database->query()) {
		echo "<script>alert('".$database->getErrorMsg()."'); window.history.go(-1);</script>\n";
		exit;
	}

	if (count($cid) == 1) {
		$row = new cbs_table($database);
		$row->checkin($cid[0]);
	}

	mosRedirect('index2.php?option=com_comprofiler&task=pluginmenu&cid='.$plugin->id.'&menu=sql');
}

function remove($plugin, $cid,  $category){
	global $database;
	$cids = implode(',', $cid);
        
	$query = "SELECT *"
	. "\n FROM #__cb_search"
	. "\n WHERE id IN ($cids)"
	;
	$database->setQuery( $query );
	$cur_defaults = $database->loadObjectList();

	for ($i = 0, $n = count($cur_defaults); $i < $n; $i ++) {
		$cur_default = & $cur_defaults[$i];
		if ($cur_default->default == 1) {
			echo "<script>alert(\"You can not delete a default Search Criteria.\"); window.history.go(-1); </script>\n";
			exit();
		}
	}	
	
	$query = "DELETE FROM #__cb_search WHERE id IN ($cids)";
	$database->setQuery( $query );
	$database->query();

	mosRedirect('index2.php?option=com_comprofiler&task=pluginmenu&cid='.$plugin->id.'&menu=sqlcategory=$category');	
}

function searchable($plugin,$cid, $searchable=1){
	global $database, $mosConfig_absolute_path;

	if (count($cid) < 1) {
		$action = $published ? _gsg_active_make : _gsg_active_notmake;
		echo "<script>alert('"._gsg_active_select.$action."'); window.history.go(-1);</script>\n";
		exit;
	}

	mosCache :: cleanCache('com_cb_search');

	$cids = implode(',', $cid);
	$query = "UPDATE #__cb_search_fields SET search=$searchable"
		."\n WHERE id IN ($cids)";
        //echo $query;
	$database->setQuery($query);
	if (!$database->query()) {
		echo "<script>alert('".$database->getErrorMsg()."'); window.history.go(-1);</script>\n";
		exit;
	}

	if (count($cid) == 1) {
		$row = new cbs_fields($database);
		$row->checkin($cid[0]);
	}

        mosRedirect('index2.php?option=com_comprofiler&task=pluginmenu&cid='.$plugin->id.'&menu=fields', "Changed Searchable Property");
}

function update($plugin){
global $database;
// we get all the customer fields and add them to the table #__cb_search
// if fields exist in table #__cb_search nothing will be done - QUERY 1
// if fields does not exist in table #__cb_search it will be added - QUERY 1
// fields exist in table #__cb_search but not any more in the #_comprofiler_fields we will delete the field in #_cb_search - QUERY 2

	$query_search = "SELECT * FROM `#__comprofiler_fields`AS j"
		  	. "\n WHERE ((( j.name)<>'NA') AND (( j.published)=1) AND (( j.profile)=1));";
	$database->setQuery( $query_search );
	$searchfields = $database->loadObjectList();
	$query_search2 = "SELECT * FROM `#__cb_search_fields`";
	$database->setQuery( $query_search2 );
	$searchfields2 = $database->loadObjectList();
	$fieldnameexist=0;
	
	//QUERY 1
	for ($s=0, $n=count( $searchfields ); $s < $n; $s++) {
		$searchfield =& $searchfields[$s];
		$fieldnameexist=0;
		for ($s2=0, $n2=count( $searchfields2 ); $s2 < $n2; $s2++) {
			$searchfield2 =& $searchfields2[$s2];
			if ( $searchfield->fieldid == $searchfield2->fieldid){
				$fieldnameexist=1;
			}
		}
		if ($fieldnameexist==0){				
			$query = "INSERT IGNORE INTO #__cb_search_fields VALUES ('',$searchfield->fieldid, 0,999)";
			$database->setQuery($query);
			$fieldnameexist=0;
			if (!$database->query()) {
				echo "<script>alert('".$database->getErrorMsg()."'); window.history.go(-1);</script>\n";
				exit;
			}
		}
	}

	$fieldnameexist2=0;
	//QUERY 2
	for ($s=0, $n=count( $searchfields2 ); $s < $n; $s++) {
		$searchfield2 =& $searchfield2s[$s];
		for ($s2=0, $n2=count( $searchfields ); $s2 < $n2; $s2++) {
			$searchfield =& $searchfields[$s2];
			if ( $searchfield2->fieldid == $searchfield->fieldid){
				$fieldnameexist2=1;
			}
		}
		if ($fieldnameexist2==0){				
			$query = "DELETE FROM #__cb_search_fields WHERE id='$searchfields2->id'";
			$database->setQuery($query);
			$fieldnameexist2=0;
			if (!$database->query()) {
				echo "<script>alert('".$database->getErrorMsg()."'); window.history.go(-1);</script>\n";
				exit;
			}
		}
	}
	
	//We will now order the fields
	$row = new cbs_fields( $database );
	$row->updateOrder();
		
	mosRedirect('index2.php?option=com_comprofiler&task=pluginmenu&cid='.$plugin->id.'&menu=fields',_CB_AS_UPDATELIST);
}

function order($plugin,$uid, $inc){
	global $database;

	$row = new cbs_fields( $database );
	$row->load($uid);
	
	if($inc>0){
		$order_adj = $inc;
	} else {
		$order_adj = $inc * 2;
	}
	
	$neworder = $row->ordering + $order_adj;
	
	$row->ordering = $neworder;
	if (!$row->store()) {
		echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	} // if	
	//$row->move($inc, "id=$row->id");
	$row->updateOrder();
	mosRedirect('index2.php?option=com_comprofiler&task=pluginmenu&cid='.$plugin->id.'&menu=fields');	
}

function saveOrder($plugin, &$cid) {
	global $database;

	$total		= count( $cid );
	$order 		= mosGetParam( $_POST, 'order', array(0) );
	$row 		= new cbs_fields( $database );

	// update ordering values
	for( $i=0; $i < $total; $i++ ) {
		$row->load( $cid[$i] );
		if ($row->ordering != $order[$i]) {
			echo $row->id."-".$row->fieldid."-".$row->ordering."-".$order[$i]."<br>";
			$row->ordering = $order[$i];
			if (!$row->store()) {
				echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
				exit();
			} // if
		} // if
	} // for

	$row->updateOrder();

	$msg 	= 'New ordering saved';
        
	mosRedirect('index2.php?option=com_comprofiler&task=pluginmenu&cid='.$plugin->id.'&menu=fields',$msg);
	
} // saveOrder	

}

?> 